



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle数据库字段数据拆分成多行（REGEXP_SUBSTR函数）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle数据库字段数据拆分成多行（REGEXP_SUBSTR函数）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 04:46:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>做多选功能时为了简便，会在某个字段中存储多个值，保存时虽然省事，但后续的查询统计时还需要拆分数据才行，因此这时需要将字段内的值分成多行以便后续使用。</p>
<p>下面这个例子实现了字段内数据的拆分：</p>
<div>
<pre class="prettyprint linenums">--创建测试表<br />
create table t_test(<br />
       t_type_id varchar2(10) primary key,--主键<br />
       t_type_name varchar2(20),--类型名称<br />
       t_text varchar2(200)--类型内容<br />
);

--写入数据<br />
insert all<br />
into t_test values('','家具','桌子,椅子,沙发,柜子,床')<br />
into t_test values('','设备','显示器,电脑,鼠标,键盘,投影仪')<br />
into t_test values('','办公用品','笔记本,签字笔,文件夹')<br />
select 1 from dual;

--查看表数据<br />
select * from t_test;

--类型内容字段拆分成多行<br />
SELECT distinct t.t_type_id,<br />
                t.t_type_name,<br />
                REGEXP_SUBSTR(t.t_text, '[^,]+', 1, level) t_text<br />
  from t_test t<br />
connect by level &lt;=<br />
           LENGTH(t.t_text) - LENGTH(regexp_replace(t.t_text, ',', '')) + 1<br />
 order by t.t_type_id, t.t_type_name;

--删除测试表<br />
drop table t_test;</pre>
</div>
<p>效果对比：</p>
<p>拆分前的原始数据：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/402798/201812/402798-20181205145511198-122126873.png" /></p>
<p>拆分后的数据：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/402798/201812/402798-20181205145534639-484262953.png" /></p>
<p>项目中用到，记录分享。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvepdy9.html">第19章 集合框架&lpar;3&rpar;-Map接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw415k8.html">float 和 inline-block的心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdlkkz8.html">JAVA实现打印机</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rl6r79.html">securtcrt session配置转xshell的session配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw6kkk9.html">一步一步教你如何在linux下配置apache&plus;tomcat（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xn7rz9.html">修改tomcat浏览器地址栏图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmyp4e9.html">JVM内存分配和回收</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvlk1q.html">mysql5&period;7创建账户并授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojg06pq.html">Asp&period;Net页面传值的方法简单总结【原创】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yv0jz8.html">Java学习笔记--监视目录变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjol239.html">寒假训练&mdash;&mdash;搜索&mdash;&mdash;C - Robot</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj5ple9.html">python基础一 ------利用生成器生成一个可迭代对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lj0j9.html">两个python安装模块后 ImportError&colon; No module named</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnk0mq.html">第五章 绘图基础（ALTWIND）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o12mwlq.html">GUI&lowbar;事件监听机制与ActionListener演示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyynwodq.html">【BZOJ1135】&lbrack;POI2009&rsqb;Lyz</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j130l49.html">SpringMVC：后台将List转为Json，传值到页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyym6egq.html">metasploitable使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g420vq.html">JFinal Web开发学习&lpar;一&rpar;开启HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjnnj49.html">USB AUDIO Device CLASS Requests</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kj01y79.html">用Python绘制一个感兴趣是数学公式图</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvko0k8.html">Predict Referendum by sklearn package</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1jeg09.html">numpy计算结果的保存&mdash;&mdash;ndarray格式数据保存</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rmpd68.html">Python简单实现KNN算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wonrgq.html">网站性能测试工具 webbench 的安装和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdwe309.html">实验七 《FBG》&mdash;-小学生课后习题答案原型设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r7ymo9.html">雷林鹏分享：jQuery EasyUI 数据网格 - 自定义排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2mk2pq.html">【转】LVDS基础、原理、图文讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25d31xq.html">Oracle表空间的创建与删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1jl309.html">实验性质的JIT compiler（Ruby2&period;6）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
